/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64;

import java.math.BigInteger;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.memory.Label;
import ru.ispras.microtesk.model.memory.Memory;

/**
 * The {@code PE} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class PE extends ProcessingElement {
  public final Memory CIA;
  public final Memory BRANCH;
  public final Memory BRANCH_INSTRUCTION;
  public final Memory SKIPOP;
  public final Memory NEXTPC;
  public final Memory JTLB;
  public final Memory GPR;
  public final Memory HI;
  public final Memory LO;
  public final Memory FPR;
  public final Memory CPR;
  public final Memory C0_INDEX;
  public final Memory C0_RANDOM;
  public final Memory C0_ENTRY_LO0;
  public final Memory C0_ENTRY_LO1;
  public final Memory C0_CONTEXT;
  public final Memory C0_PAGE_MASK;
  public final Memory C0_WIRED;
  public final Memory C0_BAD_VADDR;
  public final Memory C0_COUNT;
  public final Memory C0_ENTRY_HI;
  public final Memory C0_COMPARE;
  public final Memory C0_STATUS;
  public final Memory C0_INTCTL;
  public final Memory C0_SRSCTL;
  public final Memory C0_CAUSE;
  public final Memory C0_EPC;
  public final Memory C0_PROCESSOR_ID;
  public final Memory C0_CONFIG0;
  public final Memory C0_CONFIG0_K0;
  public final Memory C0_CONFIG1;
  public final Memory C0_CONFIG2;
  public final Memory C0_CONFIG3;
  public final Memory C0_LOAD_LINKED_ADDRESS;
  public final Memory C0_WATCH_LO;
  public final Memory C0_WATCH_HI;
  public final Memory C0_XCONTEXT;
  public final Memory C0_DEBUG;
  public final Memory C0_DEBUG_EPC;
  public final Memory C0_PERFORMANCE_COUNTER;
  public final Memory C0_ERR_CTRL;
  public final Memory C0_CACHE_ERR;
  public final Memory C0_TAG_DATA_LO;
  public final Memory C0_TAG_DATA_HI;
  public final Memory C0_ERROR_EPC;
  public final Memory C0_DESAVE;
  public final Memory C0_STATUS_RE;
  public final Memory C0_STATUS_BEV;
  public final Memory C0_STATUS_UX;
  public final Memory C0_STATUS_KSU;
  public final Memory C0_STATUS_UM;
  public final Memory C0_STATUS_R0;
  public final Memory C0_STATUS_ERL;
  public final Memory C0_STATUS_EXL;
  public final Memory C0_STATUS_IE;
  public final Memory C0_SRSCTL_HSS;
  public final Memory C0_SRSCTL_PSS;
  public final Memory C0_SRSCTL_CSS;
  public final Memory C0_CONFIG1_M;
  public final Memory C0_CONFIG1_MMUSize;
  public final Memory C0_CONFIG1_IS;
  public final Memory C0_CONFIG1_IL;
  public final Memory C0_CONFIG1_IA;
  public final Memory C0_CONFIG1_DS;
  public final Memory C0_CONFIG1_DL;
  public final Memory C0_CONFIG1_DA;
  public final Memory C0_CONFIG1_C2;
  public final Memory C0_CONFIG1_MD;
  public final Memory C0_CONFIG1_PC;
  public final Memory C0_CONFIG1_WR;
  public final Memory C0_CONFIG1_CA;
  public final Memory C0_CONFIG1_EP;
  public final Memory C0_CONFIG1_FP;
  public final Memory C0_CONFIG3_M;
  public final Memory C0_CONFIG3_SM;
  public final Memory C0_CONFIG3_TL;
  public final Memory C0_CONFIG3_ISA;
  public final Memory C0_DEBUG_DBD;
  public final Memory C0_DEBUG_DM;
  public final Memory C0_DEBUG_NoDCR;
  public final Memory C0_DEBUG_IEXI;
  public final Memory C0_DEBUG_EJTAGver;
  public final Memory C0_DEBUG_DSS;
  public final Memory CP2CPR;
  public final Memory FCR;
  public final Memory FIR;
  public final Memory FCCR;
  public final Memory FEXR;
  public final Memory FENR;
  public final Memory FCSR;
  public final Memory FCSR_FCC_1_7;
  public final Memory FCSR_FS;
  public final Memory FCSR_FCC_0;
  public final Memory FCSR_Impl;
  public final Memory FCSR_Cause;
  public final Memory FCSR_Enables;
  public final Memory FCSR_Flags;
  public final Memory FCSR_RM;
  public final Memory VPR;
  public final Memory MEM;
  public final Memory LLbit;
  public final Memory ISAMode;
  public final Memory FPConditionCode_value;
  public final Memory COMPACT_BRANCH;

  private PE() {
    super();
    this.CIA = Memory.def(Memory.Kind.REG, "CIA", TypeDefs.DWORD, 1);
    this.BRANCH = Memory.def(Memory.Kind.MEM, "BRANCH", TypeDefs.BIT, 1);
    this.BRANCH_INSTRUCTION = Memory.def(Memory.Kind.MEM, "BRANCH_INSTRUCTION", TypeDefs.BIT, 1);
    this.SKIPOP = Memory.def(Memory.Kind.MEM, "SKIPOP", TypeDefs.BIT, 1);
    this.NEXTPC = Memory.def(Memory.Kind.MEM, "NEXTPC", TypeDefs.DWORD, 1);
    this.JTLB = Memory.def(Memory.Kind.REG, "JTLB", TypeDefs.JTLB_ENTRY, 64);
    this.GPR = Memory.def(Memory.Kind.REG, "GPR", TypeDefs.DWORD, 32);
    this.HI = Memory.def(Memory.Kind.REG, "HI", TypeDefs.DWORD, 1);
    this.LO = Memory.def(Memory.Kind.REG, "LO", TypeDefs.DWORD, 1);
    this.FPR = Memory.def(Memory.Kind.REG, "FPR", TypeDefs.DWORD, 32);
    this.CPR = Memory.def(Memory.Kind.REG, "CPR", TypeDefs.DWORD, 256);
    this.C0_INDEX = Memory.def(Memory.Kind.REG, "C0_INDEX", TypeDefs.DWORD, 1, CPR.access(0));
    this.C0_RANDOM = Memory.def(Memory.Kind.REG, "C0_RANDOM", TypeDefs.DWORD, 1, CPR.access(8));
    this.C0_ENTRY_LO0 = Memory.def(Memory.Kind.REG, "C0_ENTRY_LO0", TypeDefs.DWORD, 1, CPR.access(16));
    this.C0_ENTRY_LO1 = Memory.def(Memory.Kind.REG, "C0_ENTRY_LO1", TypeDefs.DWORD, 1, CPR.access(24));
    this.C0_CONTEXT = Memory.def(Memory.Kind.REG, "C0_CONTEXT", TypeDefs.DWORD, 1, CPR.access(32));
    this.C0_PAGE_MASK = Memory.def(Memory.Kind.REG, "C0_PAGE_MASK", TypeDefs.DWORD, 1, CPR.access(40));
    this.C0_WIRED = Memory.def(Memory.Kind.REG, "C0_WIRED", TypeDefs.DWORD, 1, CPR.access(48));
    this.C0_BAD_VADDR = Memory.def(Memory.Kind.REG, "C0_BAD_VADDR", TypeDefs.DWORD, 1, CPR.access(64));
    this.C0_COUNT = Memory.def(Memory.Kind.REG, "C0_COUNT", TypeDefs.DWORD, 1, CPR.access(72));
    this.C0_ENTRY_HI = Memory.def(Memory.Kind.REG, "C0_ENTRY_HI", TypeDefs.DWORD, 1, CPR.access(80));
    this.C0_COMPARE = Memory.def(Memory.Kind.REG, "C0_COMPARE", TypeDefs.DWORD, 1, CPR.access(88));
    this.C0_STATUS = Memory.def(Memory.Kind.REG, "C0_STATUS", TypeDefs.DWORD, 1, CPR.access(96));
    this.C0_INTCTL = Memory.def(Memory.Kind.REG, "C0_INTCTL", TypeDefs.DWORD, 1, CPR.access(97));
    this.C0_SRSCTL = Memory.def(Memory.Kind.REG, "C0_SRSCTL", TypeDefs.DWORD, 1, CPR.access(98));
    this.C0_CAUSE = Memory.def(Memory.Kind.REG, "C0_CAUSE", TypeDefs.DWORD, 1, CPR.access(104));
    this.C0_EPC = Memory.def(Memory.Kind.REG, "C0_EPC", TypeDefs.DWORD, 1, CPR.access(112));
    this.C0_PROCESSOR_ID = Memory.def(Memory.Kind.REG, "C0_PROCESSOR_ID", TypeDefs.DWORD, 1, CPR.access(120));
    this.C0_CONFIG0 = Memory.def(Memory.Kind.REG, "C0_CONFIG0", TypeDefs.DWORD, 1, CPR.access(128));
    this.C0_CONFIG0_K0 = Memory.def(Memory.Kind.REG, "C0_CONFIG0_K0", Type.CARD(3), 1, C0_CONFIG0.access().bitField(2, 0));
    this.C0_CONFIG1 = Memory.def(Memory.Kind.REG, "C0_CONFIG1", TypeDefs.DWORD, 1, CPR.access(129));
    this.C0_CONFIG2 = Memory.def(Memory.Kind.REG, "C0_CONFIG2", TypeDefs.DWORD, 1, CPR.access(130));
    this.C0_CONFIG3 = Memory.def(Memory.Kind.REG, "C0_CONFIG3", TypeDefs.DWORD, 1, CPR.access(131));
    this.C0_LOAD_LINKED_ADDRESS = Memory.def(Memory.Kind.REG, "C0_LOAD_LINKED_ADDRESS", TypeDefs.DWORD, 1, CPR.access(136));
    this.C0_WATCH_LO = Memory.def(Memory.Kind.REG, "C0_WATCH_LO", TypeDefs.DWORD, 1, CPR.access(144));
    this.C0_WATCH_HI = Memory.def(Memory.Kind.REG, "C0_WATCH_HI", TypeDefs.DWORD, 1, CPR.access(152));
    this.C0_XCONTEXT = Memory.def(Memory.Kind.REG, "C0_XCONTEXT", TypeDefs.DWORD, 1, CPR.access(160));
    this.C0_DEBUG = Memory.def(Memory.Kind.REG, "C0_DEBUG", TypeDefs.DWORD, 1, CPR.access(184));
    this.C0_DEBUG_EPC = Memory.def(Memory.Kind.REG, "C0_DEBUG_EPC", TypeDefs.DWORD, 1, CPR.access(192));
    this.C0_PERFORMANCE_COUNTER = Memory.def(Memory.Kind.REG, "C0_PERFORMANCE_COUNTER", TypeDefs.DWORD, 1, CPR.access(200));
    this.C0_ERR_CTRL = Memory.def(Memory.Kind.REG, "C0_ERR_CTRL", TypeDefs.DWORD, 1, CPR.access(208));
    this.C0_CACHE_ERR = Memory.def(Memory.Kind.REG, "C0_CACHE_ERR", TypeDefs.DWORD, 1, CPR.access(216));
    this.C0_TAG_DATA_LO = Memory.def(Memory.Kind.REG, "C0_TAG_DATA_LO", TypeDefs.DWORD, 1, CPR.access(224));
    this.C0_TAG_DATA_HI = Memory.def(Memory.Kind.REG, "C0_TAG_DATA_HI", TypeDefs.DWORD, 1, CPR.access(232));
    this.C0_ERROR_EPC = Memory.def(Memory.Kind.REG, "C0_ERROR_EPC", TypeDefs.DWORD, 1, CPR.access(240));
    this.C0_DESAVE = Memory.def(Memory.Kind.REG, "C0_DESAVE", TypeDefs.DWORD, 1, CPR.access(248));
    this.C0_STATUS_RE = Memory.def(Memory.Kind.REG, "C0_STATUS_RE", TypeDefs.BIT, 1, C0_STATUS.access().bitField(25, 25));
    this.C0_STATUS_BEV = Memory.def(Memory.Kind.REG, "C0_STATUS_BEV", TypeDefs.BIT, 1, C0_STATUS.access().bitField(22, 22));
    this.C0_STATUS_UX = Memory.def(Memory.Kind.REG, "C0_STATUS_UX", TypeDefs.BIT, 1, C0_STATUS.access().bitField(5, 5));
    this.C0_STATUS_KSU = Memory.def(Memory.Kind.REG, "C0_STATUS_KSU", Type.CARD(2), 1, C0_STATUS.access().bitField(4, 3));
    this.C0_STATUS_UM = Memory.def(Memory.Kind.REG, "C0_STATUS_UM", TypeDefs.BIT, 1, C0_STATUS.access().bitField(4, 4));
    this.C0_STATUS_R0 = Memory.def(Memory.Kind.REG, "C0_STATUS_R0", TypeDefs.BIT, 1, C0_STATUS.access().bitField(3, 3));
    this.C0_STATUS_ERL = Memory.def(Memory.Kind.REG, "C0_STATUS_ERL", TypeDefs.BIT, 1, C0_STATUS.access().bitField(2, 2));
    this.C0_STATUS_EXL = Memory.def(Memory.Kind.REG, "C0_STATUS_EXL", TypeDefs.BIT, 1, C0_STATUS.access().bitField(1, 1));
    this.C0_STATUS_IE = Memory.def(Memory.Kind.REG, "C0_STATUS_IE", TypeDefs.BIT, 1, C0_STATUS.access().bitField(0, 0));
    this.C0_SRSCTL_HSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_HSS", Type.CARD(4), 1, C0_STATUS.access().bitField(29, 26));
    this.C0_SRSCTL_PSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_PSS", Type.CARD(4), 1, C0_STATUS.access().bitField(9, 6));
    this.C0_SRSCTL_CSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_CSS", Type.CARD(4), 1, C0_STATUS.access().bitField(3, 0));
    this.C0_CONFIG1_M = Memory.def(Memory.Kind.REG, "C0_CONFIG1_M", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(31, 31));
    this.C0_CONFIG1_MMUSize = Memory.def(Memory.Kind.REG, "C0_CONFIG1_MMUSize", Type.CARD(6), 1, C0_CONFIG3.access().bitField(30, 25));
    this.C0_CONFIG1_IS = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IS", Type.CARD(3), 1, C0_CONFIG3.access().bitField(24, 22));
    this.C0_CONFIG1_IL = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IL", Type.CARD(3), 1, C0_CONFIG3.access().bitField(21, 19));
    this.C0_CONFIG1_IA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IA", Type.CARD(3), 1, C0_CONFIG3.access().bitField(18, 16));
    this.C0_CONFIG1_DS = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DS", Type.CARD(3), 1, C0_CONFIG3.access().bitField(15, 13));
    this.C0_CONFIG1_DL = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DL", Type.CARD(3), 1, C0_CONFIG3.access().bitField(12, 10));
    this.C0_CONFIG1_DA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DA", Type.CARD(3), 1, C0_CONFIG3.access().bitField(9, 7));
    this.C0_CONFIG1_C2 = Memory.def(Memory.Kind.REG, "C0_CONFIG1_C2", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(6, 6));
    this.C0_CONFIG1_MD = Memory.def(Memory.Kind.REG, "C0_CONFIG1_MD", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(5, 5));
    this.C0_CONFIG1_PC = Memory.def(Memory.Kind.REG, "C0_CONFIG1_PC", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(4, 4));
    this.C0_CONFIG1_WR = Memory.def(Memory.Kind.REG, "C0_CONFIG1_WR", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(3, 3));
    this.C0_CONFIG1_CA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_CA", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(2, 2));
    this.C0_CONFIG1_EP = Memory.def(Memory.Kind.REG, "C0_CONFIG1_EP", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(1, 1));
    this.C0_CONFIG1_FP = Memory.def(Memory.Kind.REG, "C0_CONFIG1_FP", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(0, 0));
    this.C0_CONFIG3_M = Memory.def(Memory.Kind.REG, "C0_CONFIG3_M", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(31, 31));
    this.C0_CONFIG3_SM = Memory.def(Memory.Kind.REG, "C0_CONFIG3_SM", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(1, 1));
    this.C0_CONFIG3_TL = Memory.def(Memory.Kind.REG, "C0_CONFIG3_TL", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(0, 0));
    this.C0_CONFIG3_ISA = Memory.def(Memory.Kind.REG, "C0_CONFIG3_ISA", Type.CARD(2), 1, C0_CONFIG3.access().bitField(15, 14));
    this.C0_DEBUG_DBD = Memory.def(Memory.Kind.REG, "C0_DEBUG_DBD", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(31, 31));
    this.C0_DEBUG_DM = Memory.def(Memory.Kind.REG, "C0_DEBUG_DM", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(30, 30));
    this.C0_DEBUG_NoDCR = Memory.def(Memory.Kind.REG, "C0_DEBUG_NoDCR", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(29, 29));
    this.C0_DEBUG_IEXI = Memory.def(Memory.Kind.REG, "C0_DEBUG_IEXI", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(20, 20));
    this.C0_DEBUG_EJTAGver = Memory.def(Memory.Kind.REG, "C0_DEBUG_EJTAGver", Type.CARD(3), 1, C0_DEBUG.access().bitField(17, 15));
    this.C0_DEBUG_DSS = Memory.def(Memory.Kind.REG, "C0_DEBUG_DSS", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(0, 0));
    this.CP2CPR = Memory.def(Memory.Kind.REG, "CP2CPR", TypeDefs.DWORD, 256);
    this.FCR = Memory.def(Memory.Kind.REG, "FCR", TypeDefs.WORD, 32);
    this.FIR = Memory.def(Memory.Kind.REG, "FIR", TypeDefs.WORD, 1, FCR.access(0));
    this.FCCR = Memory.def(Memory.Kind.REG, "FCCR", TypeDefs.WORD, 1, FCR.access(25));
    this.FEXR = Memory.def(Memory.Kind.REG, "FEXR", TypeDefs.WORD, 1, FCR.access(26));
    this.FENR = Memory.def(Memory.Kind.REG, "FENR", TypeDefs.WORD, 1, FCR.access(28));
    this.FCSR = Memory.def(Memory.Kind.REG, "FCSR", TypeDefs.WORD, 1, FCR.access(31));
    this.FCSR_FCC_1_7 = Memory.def(Memory.Kind.REG, "FCSR_FCC_1_7", Type.CARD(7), 1, FCSR.access().bitField(31, 25));
    this.FCSR_FS = Memory.def(Memory.Kind.REG, "FCSR_FS", TypeDefs.BIT, 1, FCSR.access().bitField(24, 24));
    this.FCSR_FCC_0 = Memory.def(Memory.Kind.REG, "FCSR_FCC_0", TypeDefs.BIT, 1, FCSR.access().bitField(23, 23));
    this.FCSR_Impl = Memory.def(Memory.Kind.REG, "FCSR_Impl", Type.CARD(2), 1, FCSR.access().bitField(22, 21));
    this.FCSR_Cause = Memory.def(Memory.Kind.REG, "FCSR_Cause", Type.CARD(6), 1, FCSR.access().bitField(17, 12));
    this.FCSR_Enables = Memory.def(Memory.Kind.REG, "FCSR_Enables", Type.CARD(5), 1, FCSR.access().bitField(11, 7));
    this.FCSR_Flags = Memory.def(Memory.Kind.REG, "FCSR_Flags", Type.CARD(5), 1, FCSR.access().bitField(6, 2));
    this.FCSR_RM = Memory.def(Memory.Kind.REG, "FCSR_RM", Type.CARD(2), 1, FCSR.access().bitField(1, 0));
    this.VPR = Memory.def(Memory.Kind.REG, "VPR", TypeDefs.QWORD, 32);
    this.MEM = Memory.def(Memory.Kind.MEM, "MEM", TypeDefs.DWORD, 0x200000000L);
    this.LLbit = Memory.def(Memory.Kind.REG, "LLbit", TypeDefs.BIT, 1);
    this.ISAMode = Memory.def(Memory.Kind.REG, "ISAMode", TypeDefs.BIT, 1);
    this.FPConditionCode_value = Memory.def(Memory.Kind.REG, "FPConditionCode_value", TypeDefs.BIT, 1);
    this.COMPACT_BRANCH = Memory.def(Memory.Kind.MEM, "COMPACT_BRANCH", TypeDefs.BIT, 1);

    registerAll();
  }

  private PE(final PE other, final boolean shared) {
    super(other);
    this.CIA = other.CIA.copy();
    this.BRANCH = other.BRANCH.copy();
    this.BRANCH_INSTRUCTION = other.BRANCH_INSTRUCTION.copy();
    this.SKIPOP = other.SKIPOP.copy();
    this.NEXTPC = other.NEXTPC.copy();
    this.JTLB = other.JTLB.copy();
    this.GPR = other.GPR.copy();
    this.HI = other.HI.copy();
    this.LO = other.LO.copy();
    this.FPR = other.FPR.copy();
    this.CPR = other.CPR.copy();
    this.C0_INDEX = Memory.def(Memory.Kind.REG, "C0_INDEX", TypeDefs.DWORD, 1, CPR.access(0));
    this.C0_RANDOM = Memory.def(Memory.Kind.REG, "C0_RANDOM", TypeDefs.DWORD, 1, CPR.access(8));
    this.C0_ENTRY_LO0 = Memory.def(Memory.Kind.REG, "C0_ENTRY_LO0", TypeDefs.DWORD, 1, CPR.access(16));
    this.C0_ENTRY_LO1 = Memory.def(Memory.Kind.REG, "C0_ENTRY_LO1", TypeDefs.DWORD, 1, CPR.access(24));
    this.C0_CONTEXT = Memory.def(Memory.Kind.REG, "C0_CONTEXT", TypeDefs.DWORD, 1, CPR.access(32));
    this.C0_PAGE_MASK = Memory.def(Memory.Kind.REG, "C0_PAGE_MASK", TypeDefs.DWORD, 1, CPR.access(40));
    this.C0_WIRED = Memory.def(Memory.Kind.REG, "C0_WIRED", TypeDefs.DWORD, 1, CPR.access(48));
    this.C0_BAD_VADDR = Memory.def(Memory.Kind.REG, "C0_BAD_VADDR", TypeDefs.DWORD, 1, CPR.access(64));
    this.C0_COUNT = Memory.def(Memory.Kind.REG, "C0_COUNT", TypeDefs.DWORD, 1, CPR.access(72));
    this.C0_ENTRY_HI = Memory.def(Memory.Kind.REG, "C0_ENTRY_HI", TypeDefs.DWORD, 1, CPR.access(80));
    this.C0_COMPARE = Memory.def(Memory.Kind.REG, "C0_COMPARE", TypeDefs.DWORD, 1, CPR.access(88));
    this.C0_STATUS = Memory.def(Memory.Kind.REG, "C0_STATUS", TypeDefs.DWORD, 1, CPR.access(96));
    this.C0_INTCTL = Memory.def(Memory.Kind.REG, "C0_INTCTL", TypeDefs.DWORD, 1, CPR.access(97));
    this.C0_SRSCTL = Memory.def(Memory.Kind.REG, "C0_SRSCTL", TypeDefs.DWORD, 1, CPR.access(98));
    this.C0_CAUSE = Memory.def(Memory.Kind.REG, "C0_CAUSE", TypeDefs.DWORD, 1, CPR.access(104));
    this.C0_EPC = Memory.def(Memory.Kind.REG, "C0_EPC", TypeDefs.DWORD, 1, CPR.access(112));
    this.C0_PROCESSOR_ID = Memory.def(Memory.Kind.REG, "C0_PROCESSOR_ID", TypeDefs.DWORD, 1, CPR.access(120));
    this.C0_CONFIG0 = Memory.def(Memory.Kind.REG, "C0_CONFIG0", TypeDefs.DWORD, 1, CPR.access(128));
    this.C0_CONFIG0_K0 = Memory.def(Memory.Kind.REG, "C0_CONFIG0_K0", Type.CARD(3), 1, C0_CONFIG0.access().bitField(2, 0));
    this.C0_CONFIG1 = Memory.def(Memory.Kind.REG, "C0_CONFIG1", TypeDefs.DWORD, 1, CPR.access(129));
    this.C0_CONFIG2 = Memory.def(Memory.Kind.REG, "C0_CONFIG2", TypeDefs.DWORD, 1, CPR.access(130));
    this.C0_CONFIG3 = Memory.def(Memory.Kind.REG, "C0_CONFIG3", TypeDefs.DWORD, 1, CPR.access(131));
    this.C0_LOAD_LINKED_ADDRESS = Memory.def(Memory.Kind.REG, "C0_LOAD_LINKED_ADDRESS", TypeDefs.DWORD, 1, CPR.access(136));
    this.C0_WATCH_LO = Memory.def(Memory.Kind.REG, "C0_WATCH_LO", TypeDefs.DWORD, 1, CPR.access(144));
    this.C0_WATCH_HI = Memory.def(Memory.Kind.REG, "C0_WATCH_HI", TypeDefs.DWORD, 1, CPR.access(152));
    this.C0_XCONTEXT = Memory.def(Memory.Kind.REG, "C0_XCONTEXT", TypeDefs.DWORD, 1, CPR.access(160));
    this.C0_DEBUG = Memory.def(Memory.Kind.REG, "C0_DEBUG", TypeDefs.DWORD, 1, CPR.access(184));
    this.C0_DEBUG_EPC = Memory.def(Memory.Kind.REG, "C0_DEBUG_EPC", TypeDefs.DWORD, 1, CPR.access(192));
    this.C0_PERFORMANCE_COUNTER = Memory.def(Memory.Kind.REG, "C0_PERFORMANCE_COUNTER", TypeDefs.DWORD, 1, CPR.access(200));
    this.C0_ERR_CTRL = Memory.def(Memory.Kind.REG, "C0_ERR_CTRL", TypeDefs.DWORD, 1, CPR.access(208));
    this.C0_CACHE_ERR = Memory.def(Memory.Kind.REG, "C0_CACHE_ERR", TypeDefs.DWORD, 1, CPR.access(216));
    this.C0_TAG_DATA_LO = Memory.def(Memory.Kind.REG, "C0_TAG_DATA_LO", TypeDefs.DWORD, 1, CPR.access(224));
    this.C0_TAG_DATA_HI = Memory.def(Memory.Kind.REG, "C0_TAG_DATA_HI", TypeDefs.DWORD, 1, CPR.access(232));
    this.C0_ERROR_EPC = Memory.def(Memory.Kind.REG, "C0_ERROR_EPC", TypeDefs.DWORD, 1, CPR.access(240));
    this.C0_DESAVE = Memory.def(Memory.Kind.REG, "C0_DESAVE", TypeDefs.DWORD, 1, CPR.access(248));
    this.C0_STATUS_RE = Memory.def(Memory.Kind.REG, "C0_STATUS_RE", TypeDefs.BIT, 1, C0_STATUS.access().bitField(25, 25));
    this.C0_STATUS_BEV = Memory.def(Memory.Kind.REG, "C0_STATUS_BEV", TypeDefs.BIT, 1, C0_STATUS.access().bitField(22, 22));
    this.C0_STATUS_UX = Memory.def(Memory.Kind.REG, "C0_STATUS_UX", TypeDefs.BIT, 1, C0_STATUS.access().bitField(5, 5));
    this.C0_STATUS_KSU = Memory.def(Memory.Kind.REG, "C0_STATUS_KSU", Type.CARD(2), 1, C0_STATUS.access().bitField(4, 3));
    this.C0_STATUS_UM = Memory.def(Memory.Kind.REG, "C0_STATUS_UM", TypeDefs.BIT, 1, C0_STATUS.access().bitField(4, 4));
    this.C0_STATUS_R0 = Memory.def(Memory.Kind.REG, "C0_STATUS_R0", TypeDefs.BIT, 1, C0_STATUS.access().bitField(3, 3));
    this.C0_STATUS_ERL = Memory.def(Memory.Kind.REG, "C0_STATUS_ERL", TypeDefs.BIT, 1, C0_STATUS.access().bitField(2, 2));
    this.C0_STATUS_EXL = Memory.def(Memory.Kind.REG, "C0_STATUS_EXL", TypeDefs.BIT, 1, C0_STATUS.access().bitField(1, 1));
    this.C0_STATUS_IE = Memory.def(Memory.Kind.REG, "C0_STATUS_IE", TypeDefs.BIT, 1, C0_STATUS.access().bitField(0, 0));
    this.C0_SRSCTL_HSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_HSS", Type.CARD(4), 1, C0_STATUS.access().bitField(29, 26));
    this.C0_SRSCTL_PSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_PSS", Type.CARD(4), 1, C0_STATUS.access().bitField(9, 6));
    this.C0_SRSCTL_CSS = Memory.def(Memory.Kind.REG, "C0_SRSCTL_CSS", Type.CARD(4), 1, C0_STATUS.access().bitField(3, 0));
    this.C0_CONFIG1_M = Memory.def(Memory.Kind.REG, "C0_CONFIG1_M", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(31, 31));
    this.C0_CONFIG1_MMUSize = Memory.def(Memory.Kind.REG, "C0_CONFIG1_MMUSize", Type.CARD(6), 1, C0_CONFIG3.access().bitField(30, 25));
    this.C0_CONFIG1_IS = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IS", Type.CARD(3), 1, C0_CONFIG3.access().bitField(24, 22));
    this.C0_CONFIG1_IL = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IL", Type.CARD(3), 1, C0_CONFIG3.access().bitField(21, 19));
    this.C0_CONFIG1_IA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_IA", Type.CARD(3), 1, C0_CONFIG3.access().bitField(18, 16));
    this.C0_CONFIG1_DS = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DS", Type.CARD(3), 1, C0_CONFIG3.access().bitField(15, 13));
    this.C0_CONFIG1_DL = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DL", Type.CARD(3), 1, C0_CONFIG3.access().bitField(12, 10));
    this.C0_CONFIG1_DA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_DA", Type.CARD(3), 1, C0_CONFIG3.access().bitField(9, 7));
    this.C0_CONFIG1_C2 = Memory.def(Memory.Kind.REG, "C0_CONFIG1_C2", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(6, 6));
    this.C0_CONFIG1_MD = Memory.def(Memory.Kind.REG, "C0_CONFIG1_MD", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(5, 5));
    this.C0_CONFIG1_PC = Memory.def(Memory.Kind.REG, "C0_CONFIG1_PC", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(4, 4));
    this.C0_CONFIG1_WR = Memory.def(Memory.Kind.REG, "C0_CONFIG1_WR", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(3, 3));
    this.C0_CONFIG1_CA = Memory.def(Memory.Kind.REG, "C0_CONFIG1_CA", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(2, 2));
    this.C0_CONFIG1_EP = Memory.def(Memory.Kind.REG, "C0_CONFIG1_EP", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(1, 1));
    this.C0_CONFIG1_FP = Memory.def(Memory.Kind.REG, "C0_CONFIG1_FP", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(0, 0));
    this.C0_CONFIG3_M = Memory.def(Memory.Kind.REG, "C0_CONFIG3_M", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(31, 31));
    this.C0_CONFIG3_SM = Memory.def(Memory.Kind.REG, "C0_CONFIG3_SM", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(1, 1));
    this.C0_CONFIG3_TL = Memory.def(Memory.Kind.REG, "C0_CONFIG3_TL", TypeDefs.BIT, 1, C0_CONFIG3.access().bitField(0, 0));
    this.C0_CONFIG3_ISA = Memory.def(Memory.Kind.REG, "C0_CONFIG3_ISA", Type.CARD(2), 1, C0_CONFIG3.access().bitField(15, 14));
    this.C0_DEBUG_DBD = Memory.def(Memory.Kind.REG, "C0_DEBUG_DBD", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(31, 31));
    this.C0_DEBUG_DM = Memory.def(Memory.Kind.REG, "C0_DEBUG_DM", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(30, 30));
    this.C0_DEBUG_NoDCR = Memory.def(Memory.Kind.REG, "C0_DEBUG_NoDCR", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(29, 29));
    this.C0_DEBUG_IEXI = Memory.def(Memory.Kind.REG, "C0_DEBUG_IEXI", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(20, 20));
    this.C0_DEBUG_EJTAGver = Memory.def(Memory.Kind.REG, "C0_DEBUG_EJTAGver", Type.CARD(3), 1, C0_DEBUG.access().bitField(17, 15));
    this.C0_DEBUG_DSS = Memory.def(Memory.Kind.REG, "C0_DEBUG_DSS", TypeDefs.BIT, 1, C0_DEBUG.access().bitField(0, 0));
    this.CP2CPR = other.CP2CPR.copy();
    this.FCR = other.FCR.copy();
    this.FIR = Memory.def(Memory.Kind.REG, "FIR", TypeDefs.WORD, 1, FCR.access(0));
    this.FCCR = Memory.def(Memory.Kind.REG, "FCCR", TypeDefs.WORD, 1, FCR.access(25));
    this.FEXR = Memory.def(Memory.Kind.REG, "FEXR", TypeDefs.WORD, 1, FCR.access(26));
    this.FENR = Memory.def(Memory.Kind.REG, "FENR", TypeDefs.WORD, 1, FCR.access(28));
    this.FCSR = Memory.def(Memory.Kind.REG, "FCSR", TypeDefs.WORD, 1, FCR.access(31));
    this.FCSR_FCC_1_7 = Memory.def(Memory.Kind.REG, "FCSR_FCC_1_7", Type.CARD(7), 1, FCSR.access().bitField(31, 25));
    this.FCSR_FS = Memory.def(Memory.Kind.REG, "FCSR_FS", TypeDefs.BIT, 1, FCSR.access().bitField(24, 24));
    this.FCSR_FCC_0 = Memory.def(Memory.Kind.REG, "FCSR_FCC_0", TypeDefs.BIT, 1, FCSR.access().bitField(23, 23));
    this.FCSR_Impl = Memory.def(Memory.Kind.REG, "FCSR_Impl", Type.CARD(2), 1, FCSR.access().bitField(22, 21));
    this.FCSR_Cause = Memory.def(Memory.Kind.REG, "FCSR_Cause", Type.CARD(6), 1, FCSR.access().bitField(17, 12));
    this.FCSR_Enables = Memory.def(Memory.Kind.REG, "FCSR_Enables", Type.CARD(5), 1, FCSR.access().bitField(11, 7));
    this.FCSR_Flags = Memory.def(Memory.Kind.REG, "FCSR_Flags", Type.CARD(5), 1, FCSR.access().bitField(6, 2));
    this.FCSR_RM = Memory.def(Memory.Kind.REG, "FCSR_RM", Type.CARD(2), 1, FCSR.access().bitField(1, 0));
    this.VPR = other.VPR.copy();
    this.MEM = other.MEM.copy();
    this.LLbit = other.LLbit.copy();
    this.ISAMode = other.ISAMode.copy();
    this.FPConditionCode_value = other.FPConditionCode_value.copy();
    this.COMPACT_BRANCH = other.COMPACT_BRANCH.copy();

    registerAll();
  }

  private void registerAll() {
    addStorage(CIA);
    addStorage(BRANCH);
    addStorage(BRANCH_INSTRUCTION);
    addStorage(SKIPOP);
    addStorage(NEXTPC);
    addStorage(JTLB);
    addStorage(GPR);
    addStorage(HI);
    addStorage(LO);
    addStorage(FPR);
    addStorage(CPR);
    addStorage(C0_INDEX);
    addStorage(C0_RANDOM);
    addStorage(C0_ENTRY_LO0);
    addStorage(C0_ENTRY_LO1);
    addStorage(C0_CONTEXT);
    addStorage(C0_PAGE_MASK);
    addStorage(C0_WIRED);
    addStorage(C0_BAD_VADDR);
    addStorage(C0_COUNT);
    addStorage(C0_ENTRY_HI);
    addStorage(C0_COMPARE);
    addStorage(C0_STATUS);
    addStorage(C0_INTCTL);
    addStorage(C0_SRSCTL);
    addStorage(C0_CAUSE);
    addStorage(C0_EPC);
    addStorage(C0_PROCESSOR_ID);
    addStorage(C0_CONFIG0);
    addStorage(C0_CONFIG0_K0);
    addStorage(C0_CONFIG1);
    addStorage(C0_CONFIG2);
    addStorage(C0_CONFIG3);
    addStorage(C0_LOAD_LINKED_ADDRESS);
    addStorage(C0_WATCH_LO);
    addStorage(C0_WATCH_HI);
    addStorage(C0_XCONTEXT);
    addStorage(C0_DEBUG);
    addStorage(C0_DEBUG_EPC);
    addStorage(C0_PERFORMANCE_COUNTER);
    addStorage(C0_ERR_CTRL);
    addStorage(C0_CACHE_ERR);
    addStorage(C0_TAG_DATA_LO);
    addStorage(C0_TAG_DATA_HI);
    addStorage(C0_ERROR_EPC);
    addStorage(C0_DESAVE);
    addStorage(C0_STATUS_RE);
    addStorage(C0_STATUS_BEV);
    addStorage(C0_STATUS_UX);
    addStorage(C0_STATUS_KSU);
    addStorage(C0_STATUS_UM);
    addStorage(C0_STATUS_R0);
    addStorage(C0_STATUS_ERL);
    addStorage(C0_STATUS_EXL);
    addStorage(C0_STATUS_IE);
    addStorage(C0_SRSCTL_HSS);
    addStorage(C0_SRSCTL_PSS);
    addStorage(C0_SRSCTL_CSS);
    addStorage(C0_CONFIG1_M);
    addStorage(C0_CONFIG1_MMUSize);
    addStorage(C0_CONFIG1_IS);
    addStorage(C0_CONFIG1_IL);
    addStorage(C0_CONFIG1_IA);
    addStorage(C0_CONFIG1_DS);
    addStorage(C0_CONFIG1_DL);
    addStorage(C0_CONFIG1_DA);
    addStorage(C0_CONFIG1_C2);
    addStorage(C0_CONFIG1_MD);
    addStorage(C0_CONFIG1_PC);
    addStorage(C0_CONFIG1_WR);
    addStorage(C0_CONFIG1_CA);
    addStorage(C0_CONFIG1_EP);
    addStorage(C0_CONFIG1_FP);
    addStorage(C0_CONFIG3_M);
    addStorage(C0_CONFIG3_SM);
    addStorage(C0_CONFIG3_TL);
    addStorage(C0_CONFIG3_ISA);
    addStorage(C0_DEBUG_DBD);
    addStorage(C0_DEBUG_DM);
    addStorage(C0_DEBUG_NoDCR);
    addStorage(C0_DEBUG_IEXI);
    addStorage(C0_DEBUG_EJTAGver);
    addStorage(C0_DEBUG_DSS);
    addStorage(CP2CPR);
    addStorage(FCR);
    addStorage(FIR);
    addStorage(FCCR);
    addStorage(FEXR);
    addStorage(FENR);
    addStorage(FCSR);
    addStorage(FCSR_FCC_1_7);
    addStorage(FCSR_FS);
    addStorage(FCSR_FCC_0);
    addStorage(FCSR_Impl);
    addStorage(FCSR_Cause);
    addStorage(FCSR_Enables);
    addStorage(FCSR_Flags);
    addStorage(FCSR_RM);
    addStorage(VPR);
    addStorage(MEM);
    addStorage(LLbit);
    addStorage(ISAMode);
    addStorage(FPConditionCode_value);
    addStorage(COMPACT_BRANCH);

    addLabel(new Label("PC", CIA, 0));
  }

  @Override
  public ProcessingElement copy(final boolean shared) {
    return new PE(this, shared);
  }

  private static final class PEFactory implements Factory {
    @Override
    public PE create() {
      return new PE();
    }
  }

  public static Factory newFactory() {
    return new PEFactory();
  }
}
