/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.ctc1;
import ru.ispras.microtesk.model.mips64.mode.R;
import ru.ispras.microtesk.model.mips64.mode.FR;

/**
 * The {@code DecoderCtc1} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderCtc1 extends DecoderItem {
  private static DecoderCtc1 instance = null;

  public static DecoderCtc1 get() {
    if (null == instance) {
      instance = new DecoderCtc1();
    }
    return instance;
  }

  private DecoderCtc1() {
    super(
        32,
        true,
        "01000100110000000000000000000000",
        "11111111111000000000011111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rt = null;
    FR fs = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000100110", 2, 11))) {
      return null;
    }

    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }

    fs = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fs) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000000000", 2, 11))) {
      return null;
    }

    return newResult(new ctc1(rt, fs));
  }
}
