/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.ei;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderEi} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderEi extends DecoderItem {
  private static DecoderEi instance = null;

  public static DecoderEi get() {
    if (null == instance) {
      instance = new DecoderEi();
    }
    return instance;
  }

  private DecoderEi() {
    super(
        32,
        true,
        "01000001011000000110000000100000",
        "11111111111000001111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rt = null;

    if (!matchNextOpc(image, BitVector.valueOf("01000001011", 2, 11))) {
      return null;
    }

    rt = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rt) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0110000000100000", 2, 16))) {
      return null;
    }

    return newResult(new ei(rt));
  }
}
