/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.j;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderJ} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJ extends DecoderItem {
  private static DecoderJ instance = null;

  public static DecoderJ get() {
    if (null == instance) {
      instance = new DecoderJ();
    }
    return instance;
  }

  private DecoderJ() {
    super(
        32,
        true,
        "00001000000000000000000000000000",
        "11111100000000000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    Immediate instr_index = null;

    if (!matchNextOpc(image, BitVector.valueOf("000010", 2, 6))) {
      return null;
    }

    instr_index = readNextImmediate(image, Type.CARD(26));

    return newResult(new j(instr_index));
  }
}
