/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.jalr;
import ru.ispras.microtesk.model.mips64.mode.R;

/**
 * The {@code DecoderJalr} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJalr extends DecoderItem {
  private static DecoderJalr instance = null;

  public static DecoderJalr get() {
    if (null == instance) {
      instance = new DecoderJalr();
    }
    return instance;
  }

  private DecoderJalr() {
    super(
        32,
        true,
        "00000000000000001111100000001001",
        "11111100000111111111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rs = null;

    if (!matchNextOpc(image, BitVector.valueOf("000000", 2, 6))) {
      return null;
    }

    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("0000011111", 2, 10))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("00000", 2, 5))) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("001001", 2, 6))) {
      return null;
    }

    return newResult(new jalr(rs));
  }
}
