/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.movt_fmt;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.mips64.mode.FR;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderMovt_fmt} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMovt_fmt extends DecoderItem {
  private static DecoderMovt_fmt instance = null;

  public static DecoderMovt_fmt get() {
    if (null == instance) {
      instance = new DecoderMovt_fmt();
    }
    return instance;
  }

  private DecoderMovt_fmt() {
    super(
        32,
        true,
        "01000100000000010000000000010001",
        "11111100000000110000000000111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    IsaPrimitive op_fmt = null;
    FR fd = null;
    FR fs = null;
    Immediate cc = null;

    if (!matchNextOpc(image, BitVector.valueOf("010001", 2, 6))) {
      return null;
    }

    op_fmt = (IsaPrimitive) readNextPrimitive(image, DecoderFMT_FORMAT.get());
    if (null == op_fmt) {
      return null;
    }

    cc = readNextImmediate(image, Type.CARD(3));

    if (!matchNextOpc(image, BitVector.valueOf("01", 2, 2))) {
      return null;
    }

    fs = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fs) {
      return null;
    }

    fd = (FR) readNextPrimitive(image, DecoderFR.get());
    if (null == fd) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("010001", 2, 6))) {
      return null;
    }

    return newResult(new movt_fmt(op_fmt, fd, fs, cc));
  }
}
