/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.decoder;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.mips64.op.tlti;
import ru.ispras.microtesk.model.mips64.mode.R;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderTlti} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderTlti extends DecoderItem {
  private static DecoderTlti instance = null;

  public static DecoderTlti get() {
    if (null == instance) {
      instance = new DecoderTlti();
    }
    return instance;
  }

  private DecoderTlti() {
    super(
        32,
        true,
        "00000100000010100000000000000000",
        "11111100000111110000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R rs = null;
    Immediate immediate = null;

    if (!matchNextOpc(image, BitVector.valueOf("000001", 2, 6))) {
      return null;
    }

    rs = (R) readNextPrimitive(image, DecoderR.get());
    if (null == rs) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("01010", 2, 5))) {
      return null;
    }

    immediate = readNextImmediate(image, Type.CARD(16));

    return newResult(new tlti(rs, immediate));
  }
}
