/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.mmu.spec;

import ru.ispras.microtesk.basis.solver.integer.IntegerVariable;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSubsystem;
import java.util.Arrays;
import java.math.BigInteger;
import ru.ispras.microtesk.mmu.basis.BufferAccessEvent;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuAction;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBinding;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuBufferAccess;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuCondition;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuConditionAtom;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuExpression;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuGuard;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuSegment;
import ru.ispras.microtesk.mmu.translator.ir.spec.MmuTransition;
import java.util.ArrayList;
import java.util.List;

/**
 * The {@code IsCached} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class IsCached {
  private static IsCached INSTANCE = null;

  public static IsCached get() {
    if (null == INSTANCE) {
      INSTANCE = new IsCached();
    }
    return INSTANCE;
  }

  private int callIndex = 0;

  public final Function newCall(
      final MmuSubsystem.Builder builder,
      final IntegerVariable IsCached,
      final IntegerVariable cca) {
    return new Function(builder, callIndex++, IsCached, cca);
  }

  public static final class Function {
    public final IntegerVariable IsCached;
    public final IntegerVariable cca;



    public final MmuAction START;
    public final MmuAction STOP;

    private final MmuAction BRANCH_0;
    private final MmuAction ASSIGN_0;
    private final MmuAction BRANCH_1;
    private final MmuAction ASSIGN_1;

    private Function(
        final MmuSubsystem.Builder builder,
        final int instanceIndex,
        final IntegerVariable IsCached,
        final IntegerVariable cca) {
      final String name = String.format("IsCached_%d", instanceIndex);
      this.IsCached = IsCached; 
      this.cca = cca; 

      this.START = new MmuAction(name + ".START");
      builder.registerAction(START);
      this.STOP = new MmuAction(name + ".STOP");
      builder.registerAction(STOP);

      this.BRANCH_0 = new MmuAction(name + ".BRANCH_0");
      builder.registerAction(BRANCH_0);
      builder.registerTransition(new MmuTransition(START, BRANCH_0, new MmuGuard(MmuConditionAtom.eq(cca.field(0, 1), new BigInteger("2", 10)))));
      this.ASSIGN_0 = new MmuAction(name + ".ASSIGN_0", new MmuBinding(IsCached, new BigInteger("0", 10)));
      builder.registerAction(ASSIGN_0);
      builder.registerTransition(new MmuTransition(BRANCH_0, ASSIGN_0));
      builder.registerTransition(new MmuTransition(ASSIGN_0, STOP));
      this.BRANCH_1 = new MmuAction(name + ".BRANCH_1");
      builder.registerAction(BRANCH_1);
      builder.registerTransition(new MmuTransition(START, BRANCH_1, new MmuGuard(MmuConditionAtom.neq(cca.field(0, 1), new BigInteger("2", 10)))));
      this.ASSIGN_1 = new MmuAction(name + ".ASSIGN_1", new MmuBinding(IsCached, new BigInteger("1", 10)));
      builder.registerAction(ASSIGN_1);
      builder.registerTransition(new MmuTransition(BRANCH_1, ASSIGN_1));
      builder.registerTransition(new MmuTransition(ASSIGN_1, STOP));
    }
  }
}
