/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class dmtc0 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "dmtc0",
          dmtc0.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rd", Type.CARD(5));
      addArgument("sel", Type.CARD(3));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate rd = (Immediate) getArgument("rd", args);
      final Immediate sel = (Immediate) getArgument("sel", args);

      return new dmtc0(rt, rd, sel);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "dmtc0",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rd", Type.CARD(5));
      addArgument("sel", Type.CARD(3));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final Immediate rd = (Immediate) getArgument("rd", args);
      final Immediate sel = (Immediate) getArgument("sel", args);

      return new instruction(
        new dmtc0(
          rt,
          rd,
          sel
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final Immediate rd;
  public final Immediate sel;

  public dmtc0(final R rt, final Immediate rd, final Immediate sel) {
    assert R.INFO.isSupported(rt);
    assert Type.CARD(5).equals(rd.getType());
    assert Type.CARD(3).equals(sel.getType());

    this.rt = rt;
    this.rd = rd;
    this.sel = sel;

    addArgument("rt", rt);
    addArgument("rd", rd);
    addArgument("sel", sel);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("dmtc0 %s, $%d, %d", rt.syntax(vars__), rd.access().load().bigIntegerValue(), sel.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("01000000101%5s%5s00000000%3s", rt.image(vars__), rd.access().load().toString(), sel.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    vars__.tempCPR.access().store(rt.access(pe__, vars__).load());
    new CPRSET(new Immediate(Data.valueOf(Type.CARD(8), 0x8).multiply(Data.zeroExtend(Type.CARD(8), rd.access().load())).add(Data.zeroExtend(Type.CARD(8), sel.access().load())))).execute(pe__, vars__);
  }
}