/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;
import ru.ispras.microtesk.model.memory.Location;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class ext extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "ext",
          ext.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("pos", Type.CARD(5));
      addArgument("size", Type.CARD(5));
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate pos = (Immediate) getArgument("pos", args);
      final Immediate size = (Immediate) getArgument("size", args);

      return new ext(rt, rs, pos, size);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "ext",
          instruction.class,
          null
          );
      addArgument("rt", R.INFO);
      addArgument("rs", R.INFO);
      addArgument("pos", Type.CARD(5));
      addArgument("size", Type.CARD(5));
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rt = (R) getArgument("rt", args);
      final R rs = (R) getArgument("rs", args);
      final Immediate pos = (Immediate) getArgument("pos", args);
      final Immediate size = (Immediate) getArgument("size", args);

      return new instruction(
        new ext(
          rt,
          rs,
          pos,
          size
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rt;
  public final R rs;
  public final Immediate pos;
  public final Immediate size;

  public ext(final R rt, final R rs, final Immediate pos, final Immediate size) {
    assert R.INFO.isSupported(rt);
    assert R.INFO.isSupported(rs);
    assert Type.CARD(5).equals(pos.getType());
    assert Type.CARD(5).equals(size.getType());

    this.rt = rt;
    this.rs = rs;
    this.pos = pos;
    this.size = size;

    addArgument("rt", rt);
    addArgument("rs", rs);
    addArgument("pos", pos);
    addArgument("size", size);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("ext %s, %s, %d, %d", rt.syntax(vars__), rs.syntax(vars__), pos.access().load().bigIntegerValue(), size.access().load().bigIntegerValue());
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("011111%5s%5s%5s%5s000000", rs.image(vars__), rt.image(vars__), size.access().load().subtract(Data.valueOf(Type.CARD(5), 0x1)).toString(), pos.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    if (((pos.access().load().add(size.access().load()).subtract(Data.valueOf(Type.CARD(5), 0x1)).compareTo(Data.valueOf(Type.CARD(5), 0x1f)) > 0) || !Data.signExtend(WORD, rs.access(pe__, vars__).bitField(31, 31).load()).equals(rs.access(pe__, vars__).bitField(63, 32).load()))) {
      Execution.unpredicted();
    }
    vars__.temp0.access().store(rt.access(pe__, vars__).bitField(31, 0).load());
    vars__.temp1.access().store(Data.valueOf(WORD, 0xffffffffL));
    vars__.temp1.access().store(vars__.temp1.access().load().shiftRight(Data.valueOf(Type.CARD(5), 0x0).subtract(size.access().load())));
    vars__.temp3.access().store(rs.access(pe__, vars__).bitField(31, 0).load().and(vars__.temp1.access().load()));
    vars__.temp1.access().store(vars__.temp1.access().load().shiftLeft(pos.access().load()));
    vars__.temp3.access().store(vars__.temp3.access().load().shiftLeft(pos.access().load()));
    vars__.temp0.access().store(vars__.temp0.access().load().and(vars__.temp1.access().load().not()));
    vars__.temp0.access().store(vars__.temp0.access().load().or(vars__.temp3.access().load()));
    rt.access(pe__, vars__).store(Data.signExtend(DWORD, vars__.temp0.access().load()));
  }
}