/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.mips64.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.Execution;
import ru.ispras.microtesk.model.ProcessingElement;
import ru.ispras.microtesk.model.data.*;
import ru.ispras.microtesk.model.memory.*;
import ru.ispras.microtesk.model.*;
import ru.ispras.microtesk.model.mips64.PE;
import ru.ispras.microtesk.model.mips64.TempVars;
import ru.ispras.microtesk.model.mips64.mode.*;

import static ru.ispras.microtesk.model.mips64.TypeDefs.*;

public final class jr extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "jr",
          jr.class,
          null
          );
      addArgument("rs", R.INFO);
      addShortcut(new Info_instruction(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new jr(rs);
    }
  }
  private static final class Info_instruction extends IsaPrimitiveInfoAnd {
    Info_instruction() {
      super(
          IsaPrimitiveKind.OP,
          "jr",
          instruction.class,
          null
          );
      addArgument("rs", R.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final R rs = (R) getArgument("rs", args);

      return new instruction(
        new jr(
          rs
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final R rs;

  public jr(final R rs) {
    assert R.INFO.isSupported(rs);

    this.rs = rs;

    addArgument("rs", rs);
  }

  @Override
  public void init(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    vars__.hint.access().store(Data.valueOf(Type.CARD(5), 0x0));
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("jr %s", rs.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    return String.format("000000%5s0000000000%5s001000", rs.image(vars__), vars__.hint.access().load().toString());
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    init(vars__);
    pe__.BRANCH_INSTRUCTION.access().store(Data.valueOf(BIT, 0x1));
    pe__.BRANCH.access().store(Data.valueOf(BIT, 0x1));
    if (pe__.C0_CONFIG1_CA.access().load().equals(Data.valueOf(BIT, 0x0))) {
      pe__.NEXTPC.access().store(rs.access(pe__, vars__).load());
    } else {
      vars__.temp_bit.access().store(Data.valueOf(BIT, 0x0));
      pe__.NEXTPC.access().store(Location.concat(rs.access(pe__, vars__).bitField(63, 1), vars__.temp_bit.access().bitField(0, 0)));
      pe__.ISAMode.access().store(rs.access(pe__, vars__).bitField(0, 0).load());
    }
  }
}